﻿Imports System.Net.Sockets
Imports System.Text
Imports System.Net
Imports System.Net.NetworkInformation
Imports System.Threading
Imports System.Diagnostics

'WSA_INVALID_HANDLE             6 Specified event object handle is invalid. An application attempts to use an event object, but the specified handle is not valid. Note that this error is returned by the operating system, so the error number may change in future releases of Windows.
'WSA_NOT_ENOUGH_MEMORY          8 Insufficient memory available. An application used a Windows Sockets function that directly maps to a Windows function. The Windows function is indicating a lack of required memory resources. Note that this error is returned by the operating system, so the error number may change in future releases of Windows.
'WSA_INVALID_PARAMETER         87 One or more parameters are invalid. An application used a Windows Sockets function which directly maps to a Windows function. The Windows function is indicating a problem with one or more parameters. Note that this error is returned by the operating system, so the error number may change in future releases of Windows.
'WSA_OPERATION_ABORTED        995 Overlapped operation aborted. An overlapped operation was canceled due to the closure of the socket, or the execution of the SIO_FLUSH command in WSAIoctl. Note that this error is returned by the operating system, so the error number may change in future releases of Windows.
'WSA_IO_INCOMPLETE            996 Overlapped I/O event object not in signaled state. The application has tried to determine the status of an overlapped operation which is not yet completed. Applications that use WSAGetOverlappedResult (with the fWait flag set to FALSE) in a polling mode to determine when an overlapped operation has completed, get this error code until the operation is complete. Note that this error is returned by the operating system, so the error number may change in future releases of Windows.
'WSA_IO_PENDING               997 Overlapped operations will complete later. The application has initiated an overlapped operation that cannot be completed immediately. A completion indication will be given later when the operation has been completed. Note that this error is returned by the operating system, so the error number may change in future releases of Windows.
'WSAEINTR                   10004 Interrupted function call. A blocking operation was interrupted by a call to WSACancelBlockingCall.
'WSAEBADF                   10009 File handle is not valid. The file handle supplied is not valid.
'WSAEACCES                  10013 Permission denied. An attempt was made to access a socket in a way forbidden by its access permissions. An example is using a broadcast address for sendto without broadcast permission being set using setsockopt(SO_BROADCAST). Another possible reason for the WSAEACCES error is that when the bind function is called (on Windows NT 4.0 with SP4 and later), another application, service, or kernel mode driver is bound to the same address with exclusive access. Such exclusive access is a new feature of Windows NT 4.0 with SP4 and later, and is implemented by using the SO_EXCLUSIVEADDRUSE option.
'WSAEFAULT                  10014 Bad address. The system detected an invalid pointer address in attempting to use a pointer argument of a call. This error occurs if an application passes an invalid pointer value, or if the length of the buffer is too small. For instance, if the length of an argument, which is a sockaddr structure, is smaller than the sizeof(sockaddr).
'WSAEINVAL                  10022 Invalid argument. Some invalid argument was supplied (for example, specifying an invalid level to the setsockopt function). In some instances, it also refers to the current state of the socket—for instance, calling accept on a socket that is not listening.
'WSAEMFILE                  10024 Too many open files. Too many open sockets. Each implementation may have a maximum number of socket handles available, either globally, per process, or per thread.
'WSAEWOULDBLOCK             10035 Resource temporarily unavailable. This error is returned from operations on nonblocking sockets that cannot be completed immediately, for example recv when no data is queued to be read from the socket. It is a nonfatal error, and the operation should be retried later. It is normal for WSAEWOULDBLOCK to be reported as the result from calling connect on a nonblocking SOCK_STREAM socket, since some time must elapse for the connection to be established.
'WSAEINPROGRESS             10036 Operation now in progress. A blocking operation is currently executing. Windows Sockets only allows a single blocking operation—per- task or thread—to be outstanding, and if any other function call is made (whether or not it references that or any other socket) the function fails with the WSAEINPROGRESS error.
'WSAEALREADY                10037 Operation already in progress. An operation was attempted on a nonblocking socket with an operation already in progress—that is, calling connect a second time on a nonblocking socket that is already connecting, or canceling an asynchronous request (WSAAsyncGetXbyY) that has already been canceled or completed.
'WSAENOTSOCK                10038 Socket operation on nonsocket. An operation was attempted on something that is not a socket. Either the socket handle parameter did not reference a valid socket, or for select, a member of an fd_set was not valid.
'WSAEDESTADDRREQ            10039 Destination address required. A required address was omitted from an operation on a socket. For example, this error is returned if sendto is called with the remote address of ADDR_ANY.
'WSAEMSGSIZE                10040 Message too long. A message sent on a datagram socket was larger than the internal message buffer or some other network limit, or the buffer used to receive a datagram was smaller than the datagram itself.
'WSAEPROTOTYPE              10041 Protocol wrong type for socket. A protocol was specified in the socket function call that does not support the semantics of the socket type requested. For example, the ARPA Internet UDP protocol cannot be specified with a socket type of SOCK_STREAM.
'WSAENOPROTOOPT             10042 Bad protocol option. An unknown, invalid or unsupported option or level was specified in a getsockopt or setsockopt call.
'WSAEPROTONOSUPPORT         10043 Protocol not supported. The requested protocol has not been configured into the system, or no implementation for it exists. For example, a socket call requests a SOCK_DGRAM socket, but specifies a stream protocol.
'WSAESOCKTNOSUPPORT         10044 Socket type not supported. The support for the specified socket type does not exist in this address family. For example, the optional type SOCK_RAW might be selected in a socket call, and the implementation does not support SOCK_RAW sockets at all.
'WSAEOPNOTSUPP              10045 Operation not supported. The attempted operation is not supported for the type of object referenced. Usually this occurs when a socket descriptor to a socket that cannot support this operation is trying to accept a connection on a datagram socket.
'WSAEPFNOSUPPORT            10046 Protocol family not supported. The protocol family has not been configured into the system or no implementation for it exists. This message has a slightly different meaning from WSAEAFNOSUPPORT. However, it is interchangeable in most cases, and all Windows Sockets functions that return one of these messages also specify WSAEAFNOSUPPORT.
'WSAEAFNOSUPPORT            10047 Address family not supported by protocol family. An address incompatible with the requested protocol was used. All sockets are created with an associated address family (that is, AF_INET for Internet Protocols) and a generic protocol type (that is, SOCK_STREAM). This error is returned if an incorrect protocol is explicitly requested in the socket call, or if an address of the wrong family is used for a socket, for example, in sendto.
'WSAEADDRINUSE              10048 Address already in use. Typically, only one usage of each socket address (protocol/IP address/port) is permitted. This error occurs if an application attempts to bind a socket to an IP address/port that has already been used for an existing socket, or a socket that was not closed properly, or one that is still in the process of closing. For server applications that need to bind multiple sockets to the same port number, consider using setsockopt (SO_REUSEADDR). Client applications usually need not call bind at all—connect chooses an unused port automatically. When bind is called with a wildcard address (involving ADDR_ANY), a WSAEADDRINUSE error could be delayed until the specific address is committed. This could happen with a call to another function later, including connect, listen, WSAConnect, or WSAJoinLeaf.
'WSAEADDRNOTAVAIL           10049 Cannot assign requested address. The requested address is not valid in its context. This normally results from an attempt to bind to an address that is not valid for the local computer. This can also result from connect, sendto, WSAConnect, WSAJoinLeaf, or WSASendTo when the remote address or port is not valid for a remote computer (for example, address or port 0).
'WSAENETDOWN                10050 Network is down. A socket operation encountered a dead network. This could indicate a serious failure of the network system (that is, the protocol stack that the Windows Sockets DLL runs over), the network interface, or the local network itself.
'WSAENETUNREACH             10051 Network is unreachable. A socket operation was attempted to an unreachable network. This usually means the local software knows no route to reach the remote host.
'WSAENETRESET               10052 Network dropped connection on reset. The connection has been broken due to keep-alive activity detecting a failure while the operation was in progress. It can also be returned by setsockopt if an attempt is made to set SO_KEEPALIVE on a connection that has already failed.
'WSAECONNABORTED            10053 Software caused connection abort. An established connection was aborted by the software in your host computer, possibly due to a data transmission time-out or protocol error.
'WSAECONNRESET              10054 Connection reset by peer. An existing connection was forcibly closed by the remote host. This normally results if the peer application on the remote host is suddenly stopped, the host is rebooted, the host or remote network interface is disabled, or the remote host uses a hard close (see setsockopt for more information on the SO_LINGER option on the remote socket). This error may also result if a connection was broken due to keep-alive activity detecting a failure while one or more operations are in progress. Operations that were in progress fail with WSAENETRESET. Subsequent operations fail with WSAECONNRESET.
'WSAENOBUFS                 10055 No buffer space available. An operation on a socket could not be performed because the system lacked sufficient buffer space or because a queue was full.
'WSAEISCONN                 10056 Socket is already connected. A connect request was made on an already-connected socket. Some implementations also return this error if sendto is called on a connected SOCK_DGRAM socket (for SOCK_STREAM sockets, the to parameter in sendto is ignored) although other implementations treat this as a legal occurrence.
'WSAENOTCONN                10057 Socket is not connected. A request to send or receive data was disallowed because the socket is not connected and (when sending on a datagram socket using sendto) no address was supplied. Any other type of operation might also return this error—for example, setsockopt setting SO_KEEPALIVE if the connection has been reset.
'WSAESHUTDOWN               10058 Cannot send after socket shutdown. A request to send or receive data was disallowed because the socket had already been shut down in that direction with a previous shutdown call. By calling shutdown a partial close of a socket is requested, which is a signal that sending or receiving, or both have been discontinued.
'WSAETOOMANYREFS            10059 Too many references. Too many references to some kernel object.
'WSAETIMEDOUT               10060 Connection timed out. A connection attempt failed because the connected party did not properly respond after a period of time, or the established connection failed because the connected host has failed to respond.
'WSAECONNREFUSED            10061 Connection refused. No connection could be made because the target computer actively refused it. This usually results from trying to connect to a service that is inactive on the foreign host—that is, one with no server application running.
'WSAELOOP                   10062 Cannot translate name. Cannot translate a name.
'WSAENAMETOOLONG            10063 Name too long. A name component or a name was too long.
'WSAEHOSTDOWN               10064 Host is down. A socket operation failed because the destination host is down. A socket operation encountered a dead host. Networking activity on the local host has not been initiated. These conditions are more likely to be indicated by the error WSAETIMEDOUT.
'WSAEHOSTUNREACH            10065 No route to host. A socket operation was attempted to an unreachable host. See WSAENETUNREACH.
'WSAENOTEMPTY               10066 Directory not empty. Cannot remove a directory that is not empty.
'WSAEPROCLIM                10067 Too many processes. A Windows Sockets implementation may have a limit on the number of applications that can use it simultaneously. WSAStartup may fail with this error if the limit has been reached.
'WSAEUSERS                  10068 User quota exceeded. Ran out of user quota.
'WSAEDQUOT                  10069 Disk quota exceeded. Ran out of disk quota.
'WSAESTALE                  10070 Stale file handle reference. The file handle reference is no longer available.
'WSAEREMOTE                 10071 Item is remote. The item is not available locally.
'WSASYSNOTREADY             10091 Network subsystem is unavailable. This error is returned by WSAStartup if the Windows Sockets implementation cannot function at this time because the underlying system it uses to provide network services is currently unavailable. Users should check: That the appropriate Windows Sockets DLL file is in the current path. That they are not trying to use more than one Windows Sockets implementation simultaneously. If there is more than one Winsock DLL on your system, be sure the first one in the path is appropriate for the network subsystem currently loaded. The Windows Sockets implementation documentation to be sure all necessary components are currently installed and configured correctly. 
'WSAVERNOTSUPPORTED         10092 Winsock.dll version out of range. The current Windows Sockets implementation does not support the Windows Sockets specification version requested by the application. Check that no old Windows Sockets DLL files are being accessed.
'WSANOTINITIALISED          10093 Successful WSAStartup not yet performed. Either the application has not called WSAStartup or WSAStartup failed. The application may be accessing a socket that the current active task does not own (that is, trying to share a socket between tasks), or WSACleanup has been called too many times.
'WSAEDISCON                 10101 Graceful shutdown in progress. Returned by WSARecv and WSARecvFrom to indicate that the remote party has initiated a graceful shutdown sequence.
'WSAENOMORE                 10102 No more results. No more results can be returned by the WSALookupServiceNext function.
'WSAECANCELLED              10103 Call has been canceled. A call to the WSALookupServiceEnd function was made while this call was still processing. The call has been canceled.
'WSAEINVALIDPROCTABLE       10104 Procedure call table is invalid. The service provider procedure call table is invalid. A service provider returned a bogus procedure table to Ws2_32.dll. This is usually caused by one or more of the function pointers being NULL.
'WSAEINVALIDPROVIDER        10105 Service provider is invalid. The requested service provider is invalid. This error is returned by the WSCGetProviderInfo and WSCGetProviderInfo32 functions if the protocol entry specified could not be found. This error is also returned if the service provider returned a version number other than 2.0.
'WSAEPROVIDERFAILEDINIT     10106 Service provider failed to initialize. The requested service provider could not be loaded or initialized. This error is returned if either a service provider's DLL could not be loaded (LoadLibrary failed) or the provider's WSPStartup or NSPStartup function failed.
'WSASYSCALLFAILURE          10107 System call failure. A system call that should never fail has failed. This is a generic error code, returned under various conditions. Returned when a system call that should never fail does fail. For example, if a call to WaitForMultipleEvents fails or one of the registry functions fails trying to manipulate the protocol/namespace catalogs. Returned when a provider does not return SUCCESS and does not provide an extended error code. Can indicate a service provider implementation error.
'WSASERVICE_NOT_FOUND       10108 Service not found. No such service is known. The service cannot be found in the specified name space. 
'WSATYPE_NOT_FOUND          10109 Class type not found. The specified class was not found.
'WSA_E_NO_MORE              10110 No more results. No more results can be returned by the WSALookupServiceNext function.
'WSA_E_CANCELLED            10111 Call was canceled. A call to the WSALookupServiceEnd function was made while this call was still processing. The call has been canceled.
'WSAEREFUSED                10112 Database query was refused. A database query failed because it was actively refused.
'WSAHOST_NOT_FOUND          11001 Host not found. No such host is known. The name is not an official host name or alias, or it cannot be found in the database(s) being queried. This error may also be returned for protocol and service queries, and means that the specified name could not be found in the relevant database.
'WSATRY_AGAIN               11002 Nonauthoritative host not found. This is usually a temporary error during host name resolution and means that the local server did not receive a response from an authoritative server. A retry at some time later may be successful.
'WSANO_RECOVERY             11003 This is a nonrecoverable error. This indicates that some sort of nonrecoverable error occurred during a database lookup. This may be because the database files (for example, BSD-compatible HOSTS, SERVICES, or PROTOCOLS files) could not be found, or a DNS request was returned by the server with a severe error.
'WSANO_DATA                 11004 Valid name, no data record of requested type. The requested name is valid and was found in the database, but it does not have the correct associated data being resolved for. The usual example for this is a host name-to-address translation attempt (using gethostbyname or WSAAsyncGetHostByName) which uses the DNS (Domain Name Server). An MX record is returned but no A record—indicating the host itself exists, but is not directly reachable.
'WSA_QOS_RECEIVERS          11005 QoS receivers. At least one QoS reserve has arrived.
'WSA_QOS_SENDERS            11006 QoS senders. At least one QoS send path has arrived.
'WSA_QOS_NO_SENDERS         11007 No QoS senders. There are no QoS senders.
'WSA_QOS_NO_RECEIVERS       11008 QoS no receivers. There are no QoS receivers.
'WSA_QOS_REQUEST_CONFIRMED  11009 QoS request confirmed. The QoS reserve request has been confirmed.
'WSA_QOS_ADMISSION_FAILURE  11010 QoS admission error. A QoS error occurred due to lack of resources.
'WSA_QOS_POLICY_FAILURE     11011 QoS policy failure. The QoS request was rejected because the policy system couldn't allocate the requested resource within the existing policy.
'WSA_QOS_BAD_STYLE          11012 QoS bad style. An unknown or conflicting QoS style was encountered.
'WSA_QOS_BAD_OBJECT         11013 QoS bad object. A problem was encountered with some part of the filterspec or the provider-specific buffer in general.
'WSA_QOS_TRAFFIC_CTRL_ERROR 11014 QoS traffic control error. An error with the underlying traffic control (TC) API as the generic QoS request was converted for local enforcement by the TC API. This could be due to an out of memory error or to an internal QoS provider error.
'WSA_QOS_GENERIC_ERROR      11015 QoS generic error. A general QoS error.
'WSA_QOS_ESERVICETYPE       11016 QoS service type error. An invalid or unrecognized service type was found in the QoS flowspec.
'WSA_QOS_EFLOWSPEC          11017 QoS flowspec error. An invalid or inconsistent flowspec was found in the QOS structure.
'WSA_QOS_EPROVSPECBUF       11018 Invalid QoS provider buffer. An invalid QoS provider-specific buffer.
'WSA_QOS_EFILTERSTYLE       11019 Invalid QoS filter style. An invalid QoS filter style was used.
'WSA_QOS_EFILTERTYPE        11020 Invalid QoS filter type. An invalid QoS filter type was used.
'WSA_QOS_EFILTERCOUNT       11021 Incorrect QoS filter count. An incorrect number of QoS FILTERSPECs were specified in the FLOWDESCRIPTOR.
'WSA_QOS_EOBJLENGTH         11022 Invalid QoS object length. An object with an invalid ObjectLength field was specified in the QoS provider-specific buffer.
'WSA_QOS_EFLOWCOUNT         11023 Incorrect QoS flow count. An incorrect number of flow descriptors was specified in the QoS structure.
'WSA_QOS_EUNKOWNPSOBJ       11024 Unrecognized QoS object. An unrecognized object was found in the QoS provider-specific buffer.
'WSA_QOS_EPOLICYOBJ         11025 Invalid QoS policy object. An invalid policy object was found in the QoS provider-specific buffer.
'WSA_QOS_EFLOWDESC          11026 Invalid QoS flow descriptor. An invalid QoS flow descriptor was found in the flow descriptor list.
'WSA_QOS_EPSFLOWSPEC        11027 Invalid QoS provider-specific flowspec. An invalid or inconsistent flowspec was found in the QoS provider-specific buffer.
'WSA_QOS_EPSFILTERSPEC      11028 Invalid QoS provider-specific filterspec. An invalid FILTERSPEC was found in the QoS provider-specific buffer.
'WSA_QOS_ESDMODEOBJ         11029 Invalid QoS shape discard mode object. An invalid shape discard mode object was found in the QoS provider-specific buffer.
'WSA_QOS_ESHAPERATEOBJ      11030 Invalid QoS shaping rate object. An invalid shaping rate object was found in the QoS provider-specific buffer.
'WSA_QOS_RESERVED_PETYPE    11031 Reserved policy QoS element type. A reserved policy element was found in the QoS provider-specific buffer.

Public Class NetCom

    Private Class UdpState
        Friend udps As Socket
        Friend adapter As IPAddress
        Friend ep As EndPoint
    End Class

    Private Class TransactionData
        Friend RequestCounter As Int32
        Friend ReplayCounter As Int32
        Friend AdapterIP As IPAddress
        Friend RemoteIPEndPoint As IPEndPoint
    End Class

    Private Class AdapterData
        Friend LocalUDPSocketRX As Socket
        Friend LocalUDPSocketTX As Socket
        'see bulk replay packet for array size
        Friend LocalUDPSocketBuffer(1416) As Byte
        Friend BroadcastAddress As IPAddress
    End Class

    Friend _ComProt As String = "TH-IOT"
    Friend _ComProtVerB As String = "0.2"
    Friend _ApplicationVerB As String = "0.2"
    Friend _ComProtVer As Int16 = 2
    Friend _FirmwareVer As Int16 = 1
    Private _TransactionsDataDict As Dictionary(Of IPAddress, TransactionData) = New Dictionary(Of IPAddress, TransactionData)
    Private _Semaphore1 As Semaphore = New Semaphore(1, 1)
    Private _AdaptersDataDict As Dictionary(Of IPAddress, AdapterData) = New Dictionary(Of IPAddress, AdapterData)
    Private _TotalRequestCounter As Int32
    Private _TotalReplayCounter As Int32
    Private _TotalReceivedPacketsCounter As Int32
    Private _LocalPort As Int32
    'Private _RemotePort As Int32

    Friend Sub TX(ByVal IP As IPAddress, ByVal Data As Byte())
        Try
            If _TransactionsDataDict.ContainsKey(IP) = True Then
                RequestTrans(IP)
                _AdaptersDataDict(_TransactionsDataDict(IP).AdapterIP).LocalUDPSocketTX.SendTo(Data, Data.Length, SocketFlags.None, _TransactionsDataDict(IP).RemoteIPEndPoint)
            End If
        Catch ex As System.ArgumentNullException
            Debug.Print("IP value or _TransactionDataDict(IP).Adapter is NULL in Class_NetCom.TX")
        Catch ex As System.Collections.Generic.KeyNotFoundException
            Debug.Print("IP value not handled")
        Catch ex As Exception
            Debug.Print(ex.StackTrace.ToString())
        End Try
    End Sub

    Friend Sub FirstTXToWAN(ByVal IP As IPAddress, ByVal Port As Int32, ByVal Data As Byte())
        Dim RemoteIpep As IPEndPoint = New IPEndPoint(IP, Port)
        For Each AdapterData As KeyValuePair(Of IPAddress, AdapterData) In _AdaptersDataDict
            Try
                AdapterData.Value.LocalUDPSocketTX.SendTo(Data, Data.Length, SocketFlags.None, RemoteIpep)
            Catch ex As System.ArgumentNullException
                Debug.Print("IP value or _TransactionDataDict(IP).Adapter is NULL in Class_NetCom.TX")
            Catch ex As System.Collections.Generic.KeyNotFoundException
                Debug.Print("IP value not handled")
            Catch ex As Exception
                Debug.Print(ex.StackTrace.ToString())
            End Try
        Next
    End Sub

    Friend Sub FirstTXToLAN(ByVal Data As Byte())
        For Each AdapterData As KeyValuePair(Of IPAddress, AdapterData) In _AdaptersDataDict
            Dim ipep As IPEndPoint = New IPEndPoint(AdapterData.Value.BroadcastAddress, _LocalPort)
            Try
                AdapterData.Value.LocalUDPSocketTX.SendTo(Data, Data.Length, SocketFlags.None, ipep)
            Catch ex As System.ArgumentNullException
                Debug.Print("IP value or _TransactionDataDict(IP).Adapter is NULL in Class_NetCom.TX")
            Catch ex As System.Collections.Generic.KeyNotFoundException
                Debug.Print("IP value not handled")
            Catch ex As Exception
                Debug.Print(ex.StackTrace.ToString())
            End Try
        Next
    End Sub

    Friend Event RXEvent As RXEventHandler
    'Friend Event RXEventB As RXEventHandlerB
    Friend Delegate Sub RXEventHandler(ByVal IP As IPAddress, ByVal Data() As Byte)
    'Friend Delegate Sub RXEventHandlerB(ByVal IP As IPAddress, ByVal Data As String)

    Friend Sub GetConnectionStats(ByVal IP As IPAddress, ByRef RequestCounter As Int32, ByRef ReplayCounter As Int32)
        RequestCounter = 0
        ReplayCounter = 0
        If _TransactionsDataDict.ContainsKey(IP) = True Then
            RequestCounter = _TransactionsDataDict(IP).RequestCounter
            ReplayCounter = _TransactionsDataDict(IP).ReplayCounter
        End If
    End Sub

    'Transaction counter on requests
    Friend Sub RequestTrans(ByVal IP As IPAddress)
        If Not _TransactionsDataDict.ContainsKey(IP) = True Then
            Dim TransDataElement As TransactionData = New TransactionData
            TransDataElement.AdapterIP = _TransactionsDataDict(IP).AdapterIP
            _TransactionsDataDict.Add(IP, TransDataElement)
        End If
        _TransactionsDataDict(IP).RequestCounter += 1
    End Sub

    'Transaction counter on replays
    Friend Sub ReplayTrans(ByVal IP As IPAddress)
        If _TransactionsDataDict.ContainsKey(IP) = True Then
            _TransactionsDataDict(IP).ReplayCounter += 1
        End If
    End Sub

    Friend Sub GetTotalConnectionsStats(ByRef RequestCounter As Int32, ByRef ReplayCounter As Int32)
        RequestCounter = _TotalRequestCounter
        ReplayCounter = _TotalReplayCounter
    End Sub

    Friend Sub ResetConnectionsStats()
        For Each TransactionData As KeyValuePair(Of IPAddress, TransactionData) In _TransactionsDataDict
            TransactionData.Value.RequestCounter = 0
            TransactionData.Value.ReplayCounter = 0
        Next
        _TotalRequestCounter = 0
        _TotalReplayCounter = 0
        _TotalReceivedPacketsCounter = 0
    End Sub

    Private Function OpenCom(ByVal IPv4UnicastAddress As IPAddress, ByVal IPv4BroadcastAddress As IPAddress, ByVal IPv4NetworkMask As IPAddress, ByVal LocalPort As Int32) As Boolean
        Dim IsOpen As Boolean = False
        If Not _AdaptersDataDict.ContainsKey(IPv4UnicastAddress) = True Then
            Try
                'Rationale
                'If we use only one socket for both reception and transmission sometimes happens that transmission
                'is interrupted by async reception before it is completed and A NEW REMOTE ENDPOINT IS SET IN THE SOCKET
                '(the one that refers to the data received) and when transmission resumes the data is trasmitted 
                'to the remote endpoint present at that time in the socket, THAT IS WRONG, the original one has been
                'lost along the way by the reception
                'To avoid this problem we must use two sockets binded to the same local endpoint, one for reception
                'and one for transmission. 'We need to set "ReuseAddress" option in both receieve and transmit sockets
                'to be able to bind both sockets to the same local endpoint
                'one of the socket is used only for receive, the other only for transmit
                Dim bindipep As IPEndPoint = New IPEndPoint(IPv4UnicastAddress, LocalPort)
                Dim allipep As IPEndPoint = New IPEndPoint(0, 0)
                Dim ep As EndPoint = allipep
                Dim lsocketrx As Socket = New Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp)
                Dim lsockettx As Socket = New Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp)
                Dim State As New UdpState()
                Dim AdapterDataElement As AdapterData = New AdapterData
                lsocketrx.SetSocketOption(Net.Sockets.SocketOptionLevel.Socket, Net.Sockets.SocketOptionName.ReuseAddress, True)
                lsocketrx.Bind(bindipep)
                lsockettx.SetSocketOption(Net.Sockets.SocketOptionLevel.Socket, Net.Sockets.SocketOptionName.ReuseAddress, True)
                lsockettx.Bind(bindipep)
                State.udps = lsocketrx
                State.adapter = IPv4UnicastAddress
                State.ep = ep
                lsocketrx.BeginReceiveFrom(AdapterDataElement.LocalUDPSocketBuffer, 0, AdapterDataElement.LocalUDPSocketBuffer.Length, SocketFlags.None, ep, New AsyncCallback(AddressOf DataReceived), State)
                _AdaptersDataDict.Add(IPv4UnicastAddress, AdapterDataElement)
                _AdaptersDataDict(IPv4UnicastAddress).LocalUDPSocketRX = lsocketrx
                _AdaptersDataDict(IPv4UnicastAddress).LocalUDPSocketTX = lsockettx
                _LocalPort = LocalPort
                _AdaptersDataDict(IPv4UnicastAddress).BroadcastAddress = IPv4BroadcastAddress
                IsOpen = True
            Catch e As SocketException
                Debug.Print("UDP port" + LocalPort.ToString + " already used on adapter " + IPv4UnicastAddress.ToString)
            End Try
        End If
        Return IsOpen
    End Function

    Private Sub CloseCom()
        _Semaphore1.WaitOne()
        For Each AdapterData As KeyValuePair(Of IPAddress, AdapterData) In _AdaptersDataDict
            AdapterData.Value.LocalUDPSocketRX.Shutdown(SocketShutdown.Both)
            AdapterData.Value.LocalUDPSocketRX.Close()
            AdapterData.Value.LocalUDPSocketTX.Shutdown(SocketShutdown.Both)
            AdapterData.Value.LocalUDPSocketTX.Close()
        Next
        _Semaphore1.Release()
        _AdaptersDataDict.Clear()
        _TransactionsDataDict.Clear()
        _TotalRequestCounter = 0
        _TotalReplayCounter = 0
        _TotalReceivedPacketsCounter = 0
    End Sub

    Private Sub DataReceived(ByVal ar As IAsyncResult)
        Try
            Dim udps As Socket = CType(CType(ar.AsyncState, UdpState).udps, Socket)
            Dim adapter As IPAddress = CType(CType(ar.AsyncState, UdpState).adapter, IPAddress)
            Dim ep As EndPoint = CType(CType(ar.AsyncState, UdpState).ep, EndPoint)
            Dim bytesread As Int32 = udps.EndReceiveFrom(ar, ep)
            Dim ReceivedData() As Byte = _AdaptersDataDict(adapter).LocalUDPSocketBuffer
            ReDim Preserve ReceivedData(bytesread - 1)

            _AdaptersDataDict(adapter).LocalUDPSocketRX.BeginReceiveFrom(_AdaptersDataDict(adapter).LocalUDPSocketBuffer, 0, _AdaptersDataDict(adapter).LocalUDPSocketBuffer.Length, SocketFlags.None, ep, New AsyncCallback(AddressOf DataReceived), ar.AsyncState)

            'threading race we need a semaphore
            _Semaphore1.WaitOne()
            'create new transaction data for this specific IP, start with IP's adpater source
            Dim IP As IPAddress = CType(ep, IPEndPoint).Address
            If Not _TransactionsDataDict.ContainsKey(IP) Then
                Dim td As TransactionData = New TransactionData
                td.AdapterIP = adapter
                _TransactionsDataDict.Add(IP, td)
            End If
            _TransactionsDataDict(IP).RemoteIPEndPoint = CType(ep, IPEndPoint)
            _Semaphore1.Release()

            _TotalReceivedPacketsCounter += 1
            'moving DecodeMessage after BeginReceive the reception is faster? it seems not
            RaiseEvent RXEvent(IP, ReceivedData)

        Catch e As SocketException
            'WSAECONNRESET 10054 Connection reset by peer.
            '=== only whith two applications running on the same pc and one is closing whilst the transfer is active ===
            '=== NEVER happens when there is only one application running per PC ===
            'It is completely unexpected, period. It's a TCP condition. The UDP error when the target doesn't exist is ECONNREFUSED, and it is only delivered when you're connected. – EJP Jun 10 '15 at 7:49
            'On further investigation it appears Windows may return ECONNRESET when there is nothing listening at the target, instead of ECONNREFUSED. – EJP Jun 10 '15 at 8:08
            'Can you provide the source of that further investigation? Because it sounds like a weird thing to do in conjunction with UDP. – omatai Jun 10 '15 at 8:41
            'It appears that the Windows recvfrom documentation might hold the answer... to be confirmed. – omatai Jun 10 '15 at 8:44
            'Even though UDP is connection-less, there can be ICMP packets sent in the background to let a UDP sender know when a receiver is not available, and WinSock interprets those packets internally and can cause higher-level socket functions to fail. For instance, as documented for recvfrom(): "WSAECONNRESET - The virtual circuit was reset by the remote side executing a hard or abortive close. The application should close the socket; it is no longer usable. On a UDP-datagram socket this error indicates a previous send operation resulted in an ICMP Port Unreachable message." ... – Remy Lebeau Jun 10 '15 at 22:21
            '... and documented for sendto(): "WSAECONNRESET - The virtual circuit was reset by the remote side executing a hard or abortive close. For UPD sockets, the remote host was unable to deliver a previously sent UDP datagram and responded with a "Port Unreachable" ICMP packet. The application should close the socket as it is no longer usable." – Remy Lebeau Jun 10 '15 at 22:23 
            CloseAdapters()
            ScanAdapters(_LocalPort)

        Catch e As ObjectDisposedException
            'when the form is closing UDPClient.close() fires a dummy DataReceive where UDPClient object is not valid anymore
            Debug.Print("UdpClient object disposed by UDPClient.Close() due to CloseAdapter() [Class_NetHALCom.DataReceived()]")
        Catch e As Exception
            Debug.Print(e.StackTrace.ToString())
        End Try
    End Sub

    Private Function OpenAdapters(ByVal LocalPort As Int32) As Int32
        Dim OpenAdapter As Int32
        Dim HWAdapters As NetworkInterface() = NetworkInterface.GetAllNetworkInterfaces()
        For Each HWAdapter As NetworkInterface In HWAdapters
            If HWAdapter.OperationalStatus = OperationalStatus.Up And (HWAdapter.NetworkInterfaceType = NetworkInterfaceType.Ethernet Or HWAdapter.NetworkInterfaceType = NetworkInterfaceType.GigabitEthernet Or HWAdapter.NetworkInterfaceType = NetworkInterfaceType.Wireless80211) Then
                Dim IPv4UnicastAddress As IPAddress = IPAddress.Loopback
                Dim IPv4NetworkMask As IPAddress = IPAddress.Loopback
                For Each UIPInfo As UnicastIPAddressInformation In HWAdapter.GetIPProperties.UnicastAddresses
                    If UIPInfo.Address.AddressFamily = System.Net.Sockets.AddressFamily.InterNetwork Then
                        IPv4UnicastAddress = UIPInfo.Address
                        IPv4NetworkMask = UIPInfo.IPv4Mask
                    End If
                Next
                ' broadcast address from ip address and network mask
                Dim IPv4UnicastAddressB() As Byte = IPv4UnicastAddress.GetAddressBytes
                Dim IPv4NetworkMaskB() As Byte = IPv4NetworkMask.GetAddressBytes
                Dim IPv4BroadcastAddressB() As Byte = IPv4UnicastAddress.GetAddressBytes
                For i As Int32 = 0 To 3
                    IPv4BroadcastAddressB(i) = IPv4UnicastAddressB(i) Or Not IPv4NetworkMaskB(i)
                Next
                Dim IPv4BroadcastAddress As IPAddress = New IPAddress(IPv4BroadcastAddressB)
                If OpenCom(IPv4UnicastAddress, IPv4BroadcastAddress, IPv4NetworkMask, LocalPort) = True Then
                    OpenAdapter += 1
                End If
            End If
        Next
        Return OpenAdapter
    End Function

    Friend Sub CloseAdapters()
        CloseCom()
    End Sub

    Friend Function ScanAdapters(ByVal LocalPort As Int32) As Int32
        Return OpenAdapters(LocalPort)
    End Function

    Friend Function GetAdapterFromIP(ByVal IP As IPAddress) As IPAddress
        Dim AdapterIP As IPAddress = Nothing
        If _TransactionsDataDict.ContainsKey(IP) = True Then
            AdapterIP = _TransactionsDataDict(IP).AdapterIP
        End If
        Return AdapterIP
    End Function

End Class

